<?php
session_start();

   /***********************************************************************
   *    Copyright  2002 - 2005 Hewlett-Packard Development Company, L.P. *
   ***********************************************************************/

$_SESSION["page"] = "completetest.php";
$_SESSION["testPage"] = "completetest.php";
?>
<html>
<head>
  <meta http-equiv='content-type' content='text/html; charset=UTF-8'>
  <title>HP Insight Diagnostics</title>
  <link rel='stylesheet' type='text/css' href='stylesheets/main.css'>
<SCRIPT LANGUAGE='JavaScript' SRC='menufunctions.js'>
</SCRIPT>

</head>
<body onLoad="doTestMenuItem(1)">
<?
  //include "iocommand.php";
  include "fefunctions.php";

  $test = 0;
  $test = $_REQUEST["send"];

  $testFilter = "[@complete='1' and @fieldtest='1'";
  if ($_SESSION["testMode"] == "unattended")
    $testFilter = $testFilter . " and @interactive='0'";
  $testFilter = $testFilter . "]";

  if ($test) // if tests have been submitted
  {
	  $deviceName = $_REQUEST["deviceSelection"];
	  $stopOnError = $_REQUEST["stopOnError"];
	  $runMode = $_REQUEST["runMode"];

	  if ($runMode == "time")
	    $test = $_REQUEST["totalTestTime"];
	  else
	    $test = $_REQUEST["testLoops"];

	  $dom = domxml_new_doc("1.0");
	  $startProcess = $dom->create_element("startProcess");
	  $diagRun = $dom->create_element("diagRun");

      $diagRun->set_attribute("jobCaption", htmlentities(TR("MSG_COMPLETE_TEST"),ENT_QUOTES,'utf-8'));

	  if ($runMode == "time")
	    $diagRun->set_attribute("desiredTestTime", $test);
	  else
	    $diagRun->set_attribute("testLoops", $test);

    if ($stopOnError == "on")
      $diagRun->set_attribute("stopOnError", "1");

    $diagRun->set_attribute("language", GetLanguage());        

    if ($deviceName == "allDevices")
    {
      $idXml = new DomDocument($_SESSION["idResult"]);
      $idXpath = @xpath_new_context($idXml->document_element());
      $tests = @xpath_eval($idXpath, "/diagOutput/category/device/test".$testFilter);      
    }
    else
    {
      $idXml = new DomDocument($_SESSION["idResult"]);
      $idXpath = @xpath_new_context($idXml->document_element());
      $device = @xpath_eval($idXpath, "/diagOutput/category/device[@name='". $deviceName . "']");
	    $num_devices = count($device);
	    if ($num_devices)
      { // if found the device

	      $deviceNode = $device->nodeset[0];
	      $deviceXpath = @xpath_new_context($deviceNode);
	      $tests = @xpath_eval($deviceXpath, "/test".$testFilter);
	    }
	  }
    $num_tests = count($tests->nodeset);
	  for ($k=0; $k < $num_tests; $k++)
    {
	    $testNode = $tests->nodeset[$k];
	    $testParent = $testNode->parent_node();
      $testName = $testNode->get_attribute("name");
	    $testDescription = $testNode->get_attribute("description");
	    $testCaption = $testNode->get_attribute("caption");
	    $deviceCaption = $testParent->get_attribute("caption");
      $componentName = $testParent->get_attribute("component");
      $deviceSlot = $testParent->get_attribute("Slot");
	    $deviceName = $testParent->get_attribute("name");
     
	    $runTest = $dom->create_element("runTest");
	    $runTest->set_attribute("component", $componentName);
	    $tcLoadFilename = $componentName . ".dat";
	    $runTest->set_attribute("tcLoadFilename", $tcLoadFilename);
	    $runTest->set_attribute("language", GetLanguage());
      $runTest->set_attribute("device", $deviceName);
      $runTest->set_attribute("test", $testName);
      if ($deviceSlot != "")
        $runTest->set_attribute("Slot", $deviceSlot); // slot the ctrlr is in that the device is attached to
      $runTest->set_attribute("description", htmlentities($testDescription,ENT_QUOTES,'utf-8'));
	    $runTest->set_attribute("caption", htmlentities($deviceCaption . " - " . $testCaption,ENT_QUOTES,'utf-8'));
      if ($testNode->get_attribute("singleThread") == "1")
        $runTest->set_attribute("singleThread", "1");
      if ($testNode->get_attribute("interactive") == "1" && $_SESSION["testMode"] == "interactive")
        $runTest->set_attribute("interactive", "1");
      $runTest->set_attribute("complete", "1");

      $diagRun->append_child($runTest);
	  }

    $scheduleMode = $HTTP_POST_VARS["scheduleType"];
  
    if ($scheduleMode == "diagRun") // if we want to schedule this test
    { 
      $scheduleProcess = $dom->create_element("scheduleProcess");
      $scheduleProcess->set_attribute("hour", $HTTP_POST_VARS["scheduleHour"]);
      $scheduleProcess->set_attribute("minute", $HTTP_POST_VARS["scheduleMinute"]);
      $scheduleProcess->set_attribute("mode", $HTTP_POST_VARS["scheduleMode"]);
      $scheduleProcess->set_attribute("weekdays", $HTTP_POST_VARS["scheduleWeekdays"]);
      $scheduleProcess->set_attribute("months", $HTTP_POST_VARS["scheduleMonths"]);
      $scheduleProcess->set_attribute("monthdays",$HTTP_POST_VARS["scheduleMonthdays"]);
      $scheduleProcess->append_child($diagRun);
      $dom->append_child($scheduleProcess);
    }
    else // otherwise, run now
    {
      $startProcess->append_child($diagRun);
      $dom->append_child($startProcess);
    }

	  // debug
    //echo htmlentities($dom->html_dump_mem());
    
  	// Submit the diagRun command					  
    $runErrors = "";
    $runStatus = "";
    if (GetLanguage() == "ja")
      $diagRunStr = sprintf("%s", $dom->dump_mem(true, "UTF-8"));
    else
      $diagRunStr = sprintf("%s", $dom->dump_mem());
    $_SESSION["diagRun"] = $diagRunStr; 
    ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $diagRunStr, $runStatus, $runErrors);
    $xmldoc = new DomDocument($runStatus);+

    $_SESSION["statusxml"] = "";
    $_SESSION["lastTest"] = 99;
    $_SESSION["lastPrompt"] = "";
    $_SESSION["lastLoop"] = "";
    $_SESSION["statusDrawn"] = "false";
    unset($_SESSION["completedTests"]);

    $rootElement = $xmldoc->document_element();
    $_SESSION["testpid"] = $rootElement->get_attribute("processID");
	 	
    if ($scheduleMode != "diagRun") // if we did not schedule this test
    {
      // GO TO STATUS PAGE NOW...
      printf("<script language=\"JavaScript\">\n");
      if (IsDiagsCD() || IsPhoenix())
      {
        //remove the refresh button - it will lock up if we try to refresh whne testing
        printf("parent.parent.frames.headerFrame.document.getElementById('refresh').style.visibility = 'hidden';\n");
        printf("parent.parent.frames.headerFrame.document.getElementById('refresh').style.display = 'none';\n");
      }
      
      printf("parent.parent.frames.headerFrame.scheduledTest = '';\n");
      printf("parent.parent.frames.headerFrame.doTab(2);\n");
      printf("parent.parent.frames.menuFrame.location = 'statusmenu.php';");
      printf("</script>\n");
    }
    else
    {
      // GO TO STATUS PAGE NOW...
      printf("<script language=\"JavaScript\">\n");
      printf("parent.parent.frames.headerFrame.scheduledTest = 'complete';\n");
      printf("location = 'completetest.php';");
      printf("</script>\n");
    }
  }
  else // build the test page
  {

    $idXml = new DomDocument($_SESSION["idResult"]);
    $idXpath = @xpath_new_context($idXml->document_element());
    $devices = @xpath_eval($idXpath, "/diagOutput/category/device"); 

    printf("<table>\n");
    printf("  <tr valign=top><td class='head'>%s</td>\n", TR("MSG_COMPLETE_TEST"));
    printf("</td><td id='hasBeenScheduledMessage'  style='visiblity:hidden; display:none'>   <font color='blue'>*</font> This complete test has been scheduled");
    printf("  </tr>");
    printf("</table>\n<hr>");
    printf("<FORM name='diagRunForm' method=post>\n");
    printf("<table>\n");
    printf("  <tr valign=top>\n");
    printf("    <td colspan=2>%s:</td>\n", TR("MSG_SELECT_DEVICE"));
    printf("  </tr>\n");
    printf("  <tr valign=top>\n");
    printf("    <td colspan=2>\n");
    printf("      <SELECT NAME='deviceSelection' onChange='hideScheduledMessage();'>\n");
    printF("        <OPTION VALUE='allDevices' id='%s' SELECTED>%s</OPTION>\n", TR("MSG_ALL_DEVICES"), TR("MSG_ALL_DEVICES"));

    $num_devices = count($devices->nodeset);
    for ($i=0; $i < $num_devices; $i++)
    {
      $deviceNode = $devices->nodeset[$i];
	    $deviceXpath = @xpath_new_context($deviceNode);
	    $tests = @xpath_eval($deviceXpath, "/test".$testFilter);
      $num_tests = count($tests->nodeset);
      if ($num_tests)
      {	
        $deviceName = $deviceNode->get_attribute("name");
        $deviceCaption = $deviceNode->get_attribute("caption");
        $deviceDescription = $deviceNode->get_attribute("description");
        printf("        <OPTION VALUE='%s'>%s: %s</OPTION>\n", $deviceName, $deviceCaption, $deviceDescription);
        $mediaTests = @xpath_eval($deviceXpath, "/test[@requiresMedia='1']");
        if (count($mediaTests->nodeset))
          $ossmp = $ossmp . sprintf("mediaArray[%s] = new Array('%s','%s');\n", $i+1, $deviceName, $deviceCaption);
        else
          $ossmp = $ossmp . sprintf("mediaArray[%s] = new Array('FALSE','%s');\n", $i+1, $deviceName, $deviceCaption);
          
	    }
      else
        $ossmp = $ossmp . sprintf("mediaArray[%s] = new Array('FALSE','FALSE');\n", $i+1);

    }

    printf("      </SELECT><br>\n    </td>\n  </tr>\n");
    printf("  <tr><td><input type=radio name='runMode' value='loops' checked> %s:</td><td><INPUT NAME='testLoops' TYPE='text' VALUE='1' SIZE=3 maxlength=4 onchange=''></td>\n", TR("MSG_NUMBER_OF_LOOPS"));
    printf("  </tr>\n  <tr>\n    <td>\n");
    printf("      <input type=radio name='runMode' value='time'> %s:\n", TR("MSG_TOTAL_TEST_TIME"));
    printf("    </td>\n    <td>\n");
    printf("      <input type=text size=3 maxlength=4 name=totalTestTime VALUE='' onchange=''>\n");
    printf("    </td>\n  </tr>\n  <tr valign=top>\n    <td>\n");
    if ($_SESSION["testpid"] == "")
	    $buttonString = MakeButton(TR("MSG_BEGIN_TESTING"), "BeginTesting();");
    else
      $buttonString = MakeButton(TR("MSG_BEGIN_TESTING"), "alert('".TR("MSG_TESTING_IN_PROGRESS") . ". " . TR("MSG_PLEASE_WAIT_FOR_TESTS").".');");
	  printf("%s", $buttonString);
    printf("</td>\n    <td><input type='checkbox' name='stopOnError'>%s</td>\n", TR("MSG_STOP_ON_FIRST_ERROR"));
    printf("  </tr>\n  <tr>\n    <td colspan=2>\n");
    printf("      %s<br>\n", TR('MSG_SELECT_DEVICE_COMPLETE'));
    printf("      %s\n", TR('MSG_SELECT_ALL_DEVICES_COMPLETE'));
    if (IsOnline())
      printf("      <br>%s  <a href=# onclick='window.open(\"schedule.php?schedule=diagRun\", \"scedule\", \"width=400,height=500,dependent=yes,directories=no,hotkeys=no,location=no,menubar=no,resizeable=no,status=no,toolbar=no,alwaysRaised=yes\");'>%s</a>", TR("MSG_TEST_SCHEDULE_INSTRUCTION"), TR("MSG_SCHEDULE_THIS_TEST"));
    printf("	</td>\n  </tr>\n</table>\n");
?>
    <input type='hidden' name='send' value='1'>
	  <input type='hidden' name='scheduleType' value='1'>
    <input type='hidden' name='scheduleHour' value=''/>
    <input type='hidden' name='scheduleMinute' value=''/>
    <input type='hidden' name='scheduleMode' value=''/>
    <input type='hidden' name='scheduleWeekdays' value=''/>
    <input type='hidden' name='scheduleMonths' value=''/>
    <input type='hidden' name='scheduleMonthdays' value=''/>

	  </form>

    <script language='Javascript'>
    var mediaArray = new Array();
<?php
    printf("mediaArray[0] = new Array('allDevices','%s');\n", TR("MSG_ALL_DEVICES"));
    printf("%s", $ossmp);
?>
    if(parent.parent.frames.headerFrame.scheduledTest == "complete")
    {
      showScheduledMessage();
    }

    function BeginTesting()
    {
      for (var i=0; i <= <?php echo $num_tests;?>; i++)
      {
        if (document.diagRunForm.deviceSelection.value == mediaArray[i][0])
        {
          <?php printf("alert('%s ' + mediaArray[i][1]);\n", TR("MSG_PLEASE_INSERT_MEDIA")); ?>
          break;
        }
      }
      document.diagRunForm.submit();
    }
    </script>

<?php
  }
?>

<script language="Javascript" src="norightclick.js"></script></body>
