<?php
session_start();


   /***********************************************************************
   *    Copyright  2002 - 2005 Hewlett-Packard Development Company, L.P. *
   ***********************************************************************/



$_SESSION["page"] = "status.php";
?>
<html>
<head>
<TITLE>HP Insight Diagnostics</TITLE>
   <meta http-equiv='content-type' content='text/html; charset=UTF-8'>
<link rel='stylesheet' type='text/css' href='stylesheets/main.css'>
<script language="Javascript" src="norightclick.js"></script>  
</HEAD>
<body onload="loadPage()">
<form name='promptForm' method='POST'>
<input type=hidden value='' name='device'>
<input type=hidden value='' name='test'>
<input type=hidden value='' name='selection'>
<input type=hidden value='' name='component'>
</form>

<form name=retestForm method=POST>
<input type=hidden name=retest value="1">
</form>

<?php
//include "iocommand.php";
include "fefunctions.php";
$refresh = "no";
$prompt = 0;

$pid = $_SESSION["testpid"];
$pageNeedsReloading = true;
$testErrors = "";
$testStatus = "";

printf("<form name='cancelTestingForm' method=post>\n");
if ($pid != "")
  printf("<input type=hidden name='cancelPid' value='%s'>\n", $pid);
printf("</form>\n");



if ($pid != "" && $HTTP_POST_VARS["device"] != "" && $HTTP_POST_VARS["test"] != "" && $HTTP_POST_VARS["component"] != "" && $HTTP_POST_VARS["selection"] != "")  // prompt submitted?
{ // prompts submited correctly
  $ps = 1;
  printf("%s", $test);
  $promptStatus = "";
  $promptErrors = "";
  $promptResponse = sprintf("<sendProcessReply processID='%s'><promptResponse component='%s' device='%s' test='%s' value='%s'>%s</promptResponse></sendProcessReply>", $pid, $HTTP_POST_VARS["component"], $HTTP_POST_VARS["device"],$HTTP_POST_VARS["test"],$HTTP_POST_VARS["selection"], $HTTP_POST_VARS["selection"]);
  ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $promptResponse, $promptStatus, $promptErrors);
  $refresh = "500";

}
else if ($HTTP_POST_VARS["retest"] == "1")
{
  // Submit the diagRun command					  
  $runErrors = "";
  $runStatus = "";
  $diagRunStr = $_SESSION["diagRun"];
  ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $diagRunStr, $runStatus, $runErrors);
  $xmldoc = new DomDocument($runStatus);+

  // zero out all the globals since we are going to test again
  $_SESSION["lastTest"] = 99;
  $_SESSION["lastPrompt"]="";
  $_SESSION["statusxml"] = "";
  $_SESSION["statusDrawn"] = "false";
  unset($_SESSION["completedTests"]);
  
  $rootElement = $xmldoc->document_element();
  $_SESSION["testpid"] = $rootElement->get_attribute("processID");
  
  $refresh = "500";
}

else if ($HTTP_POST_VARS["cancelPid"] == $pid && $pid != "")
{
  // Cancel Tests
  $cancelCommand = sprintf("<cancelProcess processID='%s' />", $pid);
  ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $cancelCommand, $testStatus, $testErrors);  
  $refresh = "500";
}

else
{
  $processResult = ""; // will hold the processResult

  if ($_SESSION["statusxml"] == "" && $pid != "")
  {
    $statusCommand = sprintf("<getProcessStatus processID='%s' />", $pid);
	  $result = ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $statusCommand, $testStatus, $testErrors);
  }
  else if ($_SESSION["statusxml"] != "")
  {
    $testStatus = sprintf("%s",$_SESSION["statusxml"]);
    $_SESSION["statusDrawn"] = "false";
  }

  if ($testStatus != "")
  {
    $xmldoc = new DomDocument($testStatus);
    //echo htmlentities($xmldoc->html_dump_mem());
    $status = $xmldoc->document_element();
   	  
    $overallState = $status->get_attribute("state");
    $overallPercent = $status->get_attribute("percentComplete");
    $jobCaption = $status->get_attribute("caption");
    $product = $status->get_attribute("product"); // product comes from Dx Edit
    if ($product != "")
      $jobCaption = $jobCaption . "<br>" . $product;
    $overallTestTime = $status->get_attribute("testTime");
    $testLoops = $status->get_attribute("testLoops");
    $currentLoop = $status->get_attribute("currentLoop");
    $cancelByTimeout = $status->get_attribute("testsCanceledByTestTime");

    // reset variables so we know to redraw the page after each loop
    if ($_SESSION["lastLoop"] != $currentLoop)
    {
      unset($_SESSION["completedTests"]);
      $_SESSION["statusDrawn"] = "false";
      $_SESSION["lastLoop"] = $currentLoop;
      $_SESSION["lastTest"] = 99;
      $_SESSION["lastPrompt"] = "";
      $_SESSION["lastTest"] = "";
    }

    $desiredTestTime = $status->get_attribute("desiredTestTime");
  
    if ($testLoops != "1" && $testLoops != "")
      $loopMessage = TR("MSG_CURRENT_LOOP") . ": " . $currentLoop . " " . TR("MSG_OF") . " " . $testLoops . "&nbsp;&nbsp;&nbsp;&nbsp;";
    else
      $loopMessage = "";

    if($desiredTestTime != "")
      $overallTestTime = $overallTestTime . " " . TR("MSG_OF") . " " . $desiredTestTime;

    if ($overallState == "running")
    {
      $stateMessage = TR("MSG_TESTING_IN_PROGRESS");
	    $refresh = "2000";
    }
    else if ($overallState == "canceling")
    {
      $stateMessage = TR("MSG_CANCELING");
	    $refresh = "2000";
    }

    else if ($overallState == "canceled")
    {
      $stateMessage = TR("MSG_TEST_CANCELED");
      $_SESSION["testpid"] = "";
      // Call getProcessResult so that we can clean up the directories...
      $resulterrors = "";
      $resultstatus = "<processResult></processResult>";
      $resultcommand = sprintf("<getProcessResult processID='%s' />", $pid);
      ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $resultcommand, $resultstatus, $resulterrors);
      $doc = new DomDocument($resultstatus);
      $processResult = $doc->document_element();

      $_SESSION["statusxml"] = $testStatus;
      $pageNeedsReloading = false;
      $_SESSION["statusDrawn"] = "false";
	    $refresh = "no";

      //write canceled to factory.xml
      if (checkDiagConfig("/src", "name", "factory.xml"))
      {
        if ($xmldoc = @LoadXmlDocument($_SESSION["diagsDirectory"] . "factory.xml"))
        {
          $factoryRoot = $xmldoc->document_element();
          $factoryXML = @xpath_new_context($factoryRoot);
          $station = $factoryRoot->get_attribute("station");
          // find out what script needs to be run first
          $srcs = @xpath_eval($factoryXML, "/src[@station='$station']");
          if (count($srcs->nodeset))
          {
            $srcs->nodeset[0]->set_attribute("status", "canceled");
            $result = SaveFile("factory.xml", "harddrive", $xmldoc->html_dump_mem());
          }
        }
      }
    }

    else if ($overallState == "completed")
    {
      $_SESSION["testpid"] = "";
      if ($cancelByTimeout)
        $stateMessage = TR("MSG_TEST_TIMEOUT_CANCEL");
      else
        $stateMessage = TR("MSG_TESTING_COMPLETED");
      $_SESSION["statusDrawn"] = "false";

	    $refresh = "no";

      if ($pid != "")
      {
        // Call getProcessResult so that we can clean up the directories...
        $resulterrors = "";
        $resultstatus = "<processResult></processResult>";
        $resultcommand = sprintf("<getProcessResult processID='%s' />", $pid);
        ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $resultcommand, $resultstatus, $resulterrors);
        $doc = new DomDocument($resultstatus);
        $processResult = $doc->document_element();

        $statusNewContext = xpath_new_context($status);
        $failedTests = @xpath_eval($statusNewContext, "/processStatus[@result='failed']");
        if (count($failedTests->nodeset))
        {
          $stateMessage = $stateMessage . "  " . TR("MSG_TESTS_FAILED");
          if (checkDiagConfig("/src", "name", "factory.xml"))
          {
            if ($xmldoc = @LoadXmlDocument($_SESSION["diagsDirectory"] . "factory.xml"))
            {
              $factoryRoot = $xmldoc->document_element();
              $factoryXML = @xpath_new_context($factoryRoot);
              $station = $factoryRoot->get_attribute("station");
              // find out what script needs to be run first
              $srcs = @xpath_eval($factoryXML, "/src[@station='$station']");
              if (count($srcs->nodeset))
              {
                $srcs->nodeset[0]->set_attribute("status", "failed");
                $result = SaveFile("factory.xml", "harddrive", $xmldoc->html_dump_mem());
              }
            }
          }
        }
        else
        {
          $stateMessage = $stateMessage . "  " . TR("MSG_TESTS_PASSED");
          if (checkDiagConfig("/src", "name", "factory.xml"))
          {
            if ($xmldoc = @LoadXmlDocument($_SESSION["diagsDirectory"] . "factory.xml"))
            {
              $factoryRoot = $xmldoc->document_element();
              $factoryXML = @xpath_new_context($factoryRoot);
              $station = $factoryRoot->get_attribute("station");
              // find out what script needs to be run first
              $srcs = @xpath_eval($factoryXML, "/src[@station='$station']");
              if (count($srcs->nodeset))
              {
                $srcs->nodeset[0]->set_attribute("status", "passed");
                $result = SaveFile("factory.xml", "harddrive", $xmldoc->dump_mem());
              }
            }
          }
        }
      }

      //echo htmlentities($doc->html_dump_mem());
									    
      //save the status so don't lose it when we browse to another page
      $_SESSION["statusxml"] = $testStatus;
      $pageNeedsReloading = false;
      if (IsDiagsCD() || IsPhoenix())
      {
        printf("  <script language='Javascript'>\n");
        printf("  parent.parent.frames.headerFrame.document.getElementById('refresh').style.visibility = 'visible';\n");
        printf("  parent.parent.frames.headerFrame.document.getElementById('refresh').style.display = 'inline';\n");
        printf("  </script>");
      }
      if (checkDiagconfig("/factory/autoCloseOnFinish") && IsFactory())
        printf("<script language='Javascript'>\nparent.parent.opener=self;\nparent.parent.close();\n</script>\n");
    }
    else
    {	   
      $stateMessage = TR("MSG_NO_TESTS_RUNNING");
  	  $overallPercent = "0";
	    $refresh = "no";
    }
    // debug - display xml to web page
    //echo htmlentities($xmldoc->html_dump_mem());
    printf("<script language=Javascript>\n");
    printf("  parent.frames.statusFrame.document.getElementById('jobCaption').innerHTML = '%s';\n", TR($jobCaption));
	  printf("  parent.frames.statusFrame.document.getElementById('stateMessage').innerHTML = '%s';\n", TR($stateMessage));
    printf("  parent.frames.statusFrame.document.getElementById('overallPercent').style.width = '%s%%';\n", $overallPercent);
    printf("  parent.frames.statusFrame.document.getElementById('overallPercent').innerHTML = '<center><b>%s%%</b></center>';\n", $overallPercent);
  
    if($overallState == "running")
      printf("  parent.frames.statusFrame.document.getElementById('cancel-retest').innerHTML = '%s';\n", MakeButton(TR("MSG_CANCEL_TESTING"), "parent.frames.updateStatusFrame.document.cancelTestingForm.submit();"));
    else if ($overallState == "completed" || $overallState == "canceled")
      printf("  parent.frames.statusFrame.document.getElementById('cancel-retest').innerHTML = '%s';\n", MakeButton(TR("MSG_RETEST"), "parent.frames.updateStatusFrame.document.retestForm.submit();"));

    printf("  parent.frames.statusFrame.document.getElementById('jobLoop').innerHTML = '%s %s %s';\n", $loopMessage, TR("MSG_TEST_TIME"), $overallTestTime);
    $rowColor = "";
	
    $processStatussXpath = xpath_new_context($status);
    $processStatuss = @xpath_eval($processStatussXpath, "/processStatus");
    $num_processStatuss = count($processStatuss->nodeset);

    // I first draw all the table rows so that later we do not have to redraw them - only update their inner HTML
    // I am keeping track of whether we have drawn the rows (created all the id object) with the statusDrawn global
    if ($_SESSION["statusDrawn"] == "false")
    {
      printf("  var store = new Array();\n");
      printf("  parent.frames.statusFrame.document.getElementById('tests').innerHTML = '';\n");
      printf("  store.push('<table width=100%%>');\n");
    }

    for($i=0; $i < $num_processStatuss; $i++)
    {
      $processStatus = $processStatuss->nodeset[$i];
      $device = $processStatus->get_attribute("device");
      $test = $processStatus->get_attribute("test");
      $state = $processStatus->get_attribute("state");
      $percentComplete = $processStatus->get_attribute("percentComplete");
      $caption = $processStatus->get_attribute("caption");
      $description = $processStatus->get_attribute("description");
      $testTime = $processStatus->get_attribute("testTime");
  	  $component = $processStatus->get_attribute("component");
	    $operationCaption = $processStatus->get_attribute("OperationCaption");


      $diagEventXpath = @xpath_new_context($processStatus);
      $diagEvents = @xpath_eval($diagEventXpath, "/diagEvent");
      $num_diagEvents = count($diagEvents->nodeset);

      $diagUpdateXpath = @xpath_new_context($processStatus);
      $diagUpdates = @xpath_eval($diagUpdateXpath, "/diagUpdate");
      $num_diagUpdates = count($diagUpdates->nodeset);

      $diagPromptXpath = xpath_new_context($processStatus);
	    $diagPrompts = @xpath_eval($diagPromptXpath, "/diagPrompt");
	    $num_diagPrompts = count($diagPrompts->nodeset);
	    if ($num_diagPrompts)
	    {

        $content = $diagPrompts->nodeset[0]->get_content();

	      if (strstr($content, "\n"))	// if the tc sends a string that contains a new line character...
	        $contents = substr($content, 0, strpos($content,"\n")); // we must remove it b/c it will cause javascript errors
        else
          $contents = $content;
        if (($i == $_SESSION["lastTest"] && $contents  != $_SESSION["lastPrompt"]) || ($i != $_SESSION["lastTest"]))        
	      {
	        $promptContents = "<center>" . $contents;
	         
	        $prompt = 1;
		      $_SESSION["lastTest"] = $i;
          $_SESSION["lastPrompt"] = $contents;

          $type = $diagPrompts->nodeset[0]->get_attribute("type");
          // display the title caption if available - first introduced to support Super LED test
          $titleCaption = $diagPrompts->nodeset[0]->get_attribute("titleCaption");
          if ($titleCaption != "")
            $caption = $titleCaption;
          
	        $promptContents = $promptContents . "<br><br>";
          if ($type == "text")
          {
            $promptContents = $promptContents."<input type='text' name='promptText' size='20' id='promptText'><input type='button' value='".TR("MSG_OK")."' onclick=sendPrompt(\"".$device."\",\"".$test."\",\"".$component."\",\"document.getElementById('promptText').value\");>&nbsp";
            
          }
          else // it's a button type
          {
            printf("parent.frames.statusFrame.document.onkeydown = parent.frames.statusFrame.getKeyPress;\n");
            $optionXpath = xpath_new_context($diagPrompts->nodeset[0]);
	          $options = xpath_eval($optionXpath, "/option");
	          $num_options = count($options->nodeset);
	          for ($o=0; $o < $num_options; $o++)
	          {
	            $option = $options->nodeset[$o];
	            $optCaption = $option->get_attribute("caption");
              if ($o == 0)
                $firstButton = $optCaption;
	            $promptContents = $promptContents."<input type=button id=\"button".$optCaption."\" name=\"button".$optCaption."\" value=\"".$optCaption."\" onclick=sendPrompt(\"".$device."\",\"".$test."\",\"".$component."\",".$o.");>&nbsp";
	          }
          }
	        $promptContents = $promptContents . "</center>";
          printf("  parent.frames.statusFrame.document.getElementById('cancel-retest').style.visibility = 'hidden';\n");
	        printf("  parent.frames.statusFrame.document.getElementById('handleIt').innerHTML = '%s';\n", $caption);
	        printf("  parent.frames.statusFrame.document.getElementById('scrollContentIt').innerHTML = '%s';\n", $promptContents);
	        printf("  parent.frames.statusFrame.document.getElementById('rootIt').style.display = 'inline';\n");
	        printf("  parent.frames.statusFrame.document.getElementById('rootIt').style.visibility = 'visible';\n");
          
          if ($type == "text")
            printf("  parent.frames.statusFrame.document.getElementById('promptText').focus();\n");
          else
            printf("  parent.frames.statusFrame.document.getElementById('button%s').focus();\n", $firstButton);
            
	      }
	    }

      $description = $processStatus->get_attribute("description");
      if ($state == "waiting")
        $percentComplete = "0";		
      else
        $percentComplete = $processStatus->get_attribute("percentComplete");

      if ($state == "completed")
      {
        $state = $processStatus->get_attribute("result");
        if ($state == "passed")
        {
          $state = TR("MSG_PASSED");
          $gif = "ok.gif";
        }
	      else if ($state == "failed")
        {
          $state = TR("MSG_FAILED");
          $gif = "failed.gif";
        }
        else
        {
          $state = "";
          $gif = "unknown.gif";
        }
	    }
	    else if ($state == "crashed")
      {
        $state = TR("MSG_ABNORMAL_TERMINATION");
        $gif = "failed.gif";
      }
	    else
      {
        $gif = "unknown.gif";
      }
      
      if ($operationCaption != "")
        $state = $state . ": " . $operationCaption;

	
      // have we already drawn out all the id objects?  
      if ($_SESSION["statusDrawn"] == "false")
      {
        printf("  store.push('<tr bgcolor=\"%s\">');\n", $rowColor);

        $captionString = sprintf("<td width=40%%><img id=\"gif%s\" src=\"%s\">&nbsp;&nbsp;<span id=\"caption%s\">%s</span></td>",$i,$gif,$i, $caption);
        printf("  store.push('%s');\n", $captionString);

        $stateString = sprintf("<td width=35%% id=\"state%s\">%s</td>", $i, $state);
        printf("  store.push('%s');\n", $stateString);
    
        if ($percentComplete == "")
          $percentComplete = "0";

        $percentString = sprintf("<td width=15%%><div style=\"border:thin inset; width:100%%\"><div id=\"progress%s\"style=\"background-color:#3399CC; width:%s%%\"><center><b>%s%%</b></center></div></div></td>", $i, $percentComplete, $percentComplete);
        printf("  store.push('%s');\n", $percentString);

        $timeString = sprintf("<td width=\"0\" id=\"testTime%s\">%s</td></tr>", $i, $testTime);
	      printf("  store.push('%s');\n", $timeString);

        // Alternate the row color
	      if($rowColor == "")
	        $rowColor = "#eeeeee"; // make gray
	      else
	        $rowColor = ""; // make white	  
      }
      else if ($_SESSION["completedTests"][$i] != "1") // has the test already passed? if so, there is no need to update anything on it
      {
        if ($state != "running" && $state != "waiting" && $state != "" && $gif != "unknown.gif") // is the test finished?
          $_SESSION["completedTests"][$i] = "1";  // yes, so keep track of it and so we do not update it again

        printf("var gif = parent.frames.statusFrame.document.getElementById('gif%s').src;\n", $i);
        if ($percentComplete > 0)
        {
          printf("if (gif.indexOf(\"unknown\") != -1)\n{\n");
          printf("  parent.frames.statusFrame.document.getElementById('gif%s').src = '%s';\n", $i,$gif);
          printf("  parent.frames.statusFrame.document.getElementById('state%s').innerHTML = '%s';\n", $i,$state);
          printf("  parent.frames.statusFrame.document.getElementById('progress%s').style.width = '%s%%';\n", $i, $percentComplete);
          printf("  parent.frames.statusFrame.document.getElementById('progress%s').innerHTML = '<center>%s%%</center>';\n", $i, $percentComplete);
          printf("  parent.frames.statusFrame.document.getElementById('testTime%s').innerHTML = '%s';\n", $i, $testTime);
          printf("}\n");
        }
      }
    }

    if ($_SESSION["statusDrawn"] == "false" && $num_processStatuss)
   	{
   	  printf("  store.push('</table>');\n");
	    printf("  var writestring = store.join('');\n");
	    printf("  parent.frames.statusFrame.document.getElementById('tests').innerHTML = writestring;\n");
      $_SESSION["statusDrawn"] = "true";
    } 
    printf("</script>\n");
  }
  
}
?>
<script language=Javascript>
  var theHandle, theRoot;
  function loadPage()
  {
<?php
if ($prompt != 1 && $refresh != "no")
  printf("    setTimeout('location=location','%s');\n", $refresh);
printf("}\n");

?>
  
</script>



</body>
